﻿using System.Windows;
using System.Windows.Controls;
using System.Windows.Media;
using System.Collections.ObjectModel;
using System.Collections.Generic;

namespace Validacao_SilverLight
{
    public partial class MainPage : UserControl
    {
        public MainPage()
        {
            InitializeComponent();

            //inicializar a coleção Contato com dados
            ObservableCollection<Contato> contatoColecao = new ObservableCollection<Contato>();

            contatoColecao.Add(new Contato
            {
                Nome = "Macoratti",
                Email = "macoratti@yahoo.com",
                Telefone = "1125551212",
                Endereco = new Endereco
                {
                    Rua = "Rua Pojetada 2000",
                    Cidade = "Lins",
                    Estado = "SP",
                    Cep = "13005456"
                }
            });

            contatoColecao.Add(new Contato
            {
                Nome = "Jefferson",
                Email = "jeff@bol.com.br",
                Telefone = "6185551212",
                Endereco = new Endereco
                {
                    Rua = "Pça da Amizada 11000",
                    Cidade = "Brasilia",
                    Estado = "DF",
                    Cep = "77500421"
                }
            });

            contatoColecao.Add(new Contato
            {
                Nome = "Janice",
                Email = "janice@uol.com.br",
                Telefone = "2125551212",
                Endereco = new Endereco
                {
                    Rua = "Av. Independencia 1200",
                    Cidade = "Rio de Janeiro",
                    Estado = "RJ",
                    Cep = "21016520"
                }
            });

            lbx_Contatos.ItemsSource = contatoColecao;

            this.BindingValidationError +=
              new System.EventHandler<ValidationErrorEventArgs>((s, e) =>
              {

                  if (lbx_Contatos.SelectedItem == null) return;
                  //Alterar a propriedade InError property do contato selecionado
                  if (e.Action == ValidationErrorEventAction.Added)
                      (lbx_Contatos.SelectedItem as Contato).InError = true;
                  else
                      (lbx_Contatos.SelectedItem as Contato).InError = false;

              });

        }

        private void btn_Novo_Click(object sender, RoutedEventArgs e)
        {
            //Obtema coleção vinculada
            ObservableCollection<Contato> contatoColecao =
              (ObservableCollection<Contato>)lbx_Contatos.ItemsSource;
            //cria e incializar o novo contato
            Contato novoContato = new Contato();
            novoContato.Endereco = new Endereco();
            //inclui o contato na coleção
            contatoColecao.Add(novoContato);
            //define a seleção atual to novo contato incluido
            //Dessa forma teremos uma mudanção na seleção que ira definir o novo datacontext 
            //datacontext for the form appropriately
            lbx_Contatos.SelectedItem = novoContato;

        }

        private void lbx_Contatos_SelectionChanged(object sender,
          SelectionChangedEventArgs e)
        {
            //define o datacontext do formulário par ao contato selecionado
            grid_ContatoForm.DataContext = (Contato)lbx_Contatos.SelectedItem;
            //exibe o formulário
            border_ContatoForm.Visibility = Visibility.Visible;
            grid_NewButton.Visibility = Visibility.Collapsed;
        }

        private void btnFechar_Click(object sender, RoutedEventArgs e)
        {
            //esconde o formulário
            if (lbx_Contatos.SelectedItem != null)
                (lbx_Contatos.SelectedItem as Contato).InError = false;
            border_ContatoForm.Visibility = Visibility.Collapsed;
            grid_NewButton.Visibility = Visibility.Visible;
        }
    }
}
